Foreman - Bug #13545

Editing template throws "undefined method "profile=' for nil:NilClass" error
02/03/2016 10:34 AM - Dima Nilsen

Status: Closed
Priority: Normal
Assignee: Justin Sherrill
Category: Templates
Target version: 1.10.3
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1312916 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3244
Description

as a user, | try to access provisioning templates for edit. | am getting in the webGUI:
undefined method “profile=" for nil:NilClass

permission in the Role are set to:
Provisioning template: view_provisioning_templates, edit_provisioning_templates, create_provisioning_templates

here is the log:

| Started GET "/templates/provisioning_templates/147-Discovery%$20Red%20Hat%$20kexec/edit" for 141.
52.72.231 at 2016-02-03 10:32:00 -0500
2016-02-03 10:32:00 [app] [I] Processing by ProvisioningTemplatesController#edit as */*
2016-02-03 10:32:00 [app] I[1I] Parameters: {"id"=>"147-Discovery Red Hat kexec"}
2016-02-03 10:32:00 [app] I[1I] Rendered provisioning_templates/_custom_tab_headers.html.erb (0.4m
s)
2016-02-03 10:32:00 [app] I[I] Rendered editor/_toolbar.html.erb (10.4ms)
2016-02-03 10:32:00 [app] I[I] Rendered templates/_form.html.erb (20.4ms)
2016-02-03 10:32:00 [app] [I] Rendered provisioning_templates/edit.html.erb (21.4ms)
2016-02-03 10:32:00 [app] [W] Action failed

| NoMethodError: undefined method "profile=' for nil:NilClass

| /opt/theforeman/tfm/root/usr/share/gems/gems/scoped_search-3.2.2/1ib/scoped_search/query_builde
r.rb:38:in “initialize'

| /opt/theforeman/tfm/root/usr/share/gems/gems/scoped_search-3.2.2/1ib/scoped_search/query_builde
r.rb:22:in "new'

| /opt/theforeman/tfm/root/usr/share/gems/gems/scoped_search-3.2.2/1ib/scoped_search/query_builde
r.rb:22:in “build_query'

| /usr/share/foreman/app/services/authorizer.rb:85:in "build_filtered_scope_components'
| /usr/share/foreman/app/services/authorizer.rb:49:in "find_collection’

| /usr/share/foreman/app/models/concerns/authorizable.rb:21:in “block (2 levels) in <module:Autho
rizable>"

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/scoping/named.rb:
180:in “call’

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/scoping/named.rb:
180:in "block (2 levels) in scope'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/scoping/default.r
b:41:in "block in unscoped'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/relation.rb:241:1
n “block in scoping'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/scoping.rb:98:1in
‘with_scope'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/relation.rb:241:1
n "~ scoping'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/scoping/default.r
b:41:in “unscoped'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/scoping/named.rb:
180:in "block in scope'

| /usr/share/foreman/app/models/concerns/authorizable.rb:66:in "authorized'
/usr/share/foreman/app/models/host.rb:15:in ‘method_missing'
/usr/share/foreman/app/models/template.rb:33:in “preview_host_collection'
/usr/share/foreman/app/models/provisioning_template.rb:158:in ‘preview_host_collection’
" _31546ab5c98afllbdf76£07772cl222c"
‘b

/usr/share/foreman/app/views/editor/_toolbar.html.erb:18:in
| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack—-3.2.8/1lib/action_view/template.rb:145:1in
lock in render'
| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r

b:125:in "instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/template.rb:143:in “r
ender'’

| /opt/theforeman/tfm/root/usr/share/gems/gems/deface-1.0.1/1ib/deface/action_view_extensions.rb:
41:in “render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/partial_rend
erer.rpb:265:in "render_partial'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/partial_rend
erer.rpb:238:in "block in render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/abstract_ren

derer.rb:38:in "block in instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r
b:123:in “block in instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications/1i
nstrumenter.rb:20:1in "~ instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r

b:123:in "~ instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/abstract_ren
derer.rb:38:in "instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/partial_rend
erer.rb:237:in " render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/renderer.rb:
41:in “render_partial’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/renderer.rb:
15:in “render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/helpers/rendering_hel
per.rb:24:in "render'

| /usr/share/foreman/app/views/templates/_form.html.erb:52:in “block in _239f2387f3247f4671e320cf
dd6959ch’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/helpers/capture_helpe
r.rb:40:in "block in capture'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/helpers/capture_helpe
r.rb:187:in “with_output_buffer'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/helpers/capture_helpe
r.rb:40:in "~ capture'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/helpers/form_helper.r
b:607:in "~ fields_for'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/helpers/form_helper.r
b:378:in "~ form_for'

/usr/share/foreman/app/helpers/layout_helper.rb:400:1in

“form_for'

T _239f2387£3247£4671e320cfdd6959chb"’
b

| /usr/share/foreman/app/views/templates/_form.html.erb:2:in

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/template.rb:145:1in
lock in render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r
b:125:in

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.
ender'’

“instrument'

2.8/1lib/action_view/template.rb:143:in "r

| /opt/theforeman/tfm/root/usr/share/gems/gems/deface-1.0.1/1ib/deface/action_view_extensions.rb:
41:in "render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.
erer.rb:265:in "render_partial'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.
erer.rb:238:in "block in render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.
derer.rb:38:in "block in instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r
b:123:in

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications/1i

2.8/1lib/action_view/renderer/partial_rend

2.8/1lib/action_view/renderer/partial_rend

2.8/lib/action_view/renderer/abstract_ren

"block in instrument'
nstrumenter.rb:20:in "~ instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r
b:123:in "instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/abstract_ren
derer.rb:38:in "instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/partial_rend
erer.rb:237:in "render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1ib/action_view/renderer/renderer.rb:
41:in “render_partial’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/renderer.rb:
15:in “render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/helpers/rendering_hel
per.rb:24:in "“render'

| /usr/share/foreman/app/views/provisioning_templates/edit.html.erb:3:in ~_5037a4d30b2c44fda78bee
a44e08bad4’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/template.rb:145:in b
lock in render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r
b:125:in "instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/template.rb:143:in 'r
ender'

| /opt/theforeman/tfm/root/usr/share/gems/gems/deface-1.0.1/1ib/deface/action_view_extensions.rb:
41:in “render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/template_ren
derer.rb:47:in "block (2 levels) in render_template'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/abstract_ren
derer.rb:38:in "block in instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r
b:123:in “block in instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport—-3.2.8/1lib/active_support/notifications/i
nstrumenter.rb:20:1in "~ instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r
b:123:in "~ instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/abstract_ren
derer.rb:38:in "instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/template_ren
derer.rb:46:in "block in render_template'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/template_ren
derer.rb:54:in "render_with_layout'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/template_ren
derer.rb:45:in "render_template’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/template_ren
derer.rb:18:in "render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/renderer.rb:
36:in “render_template'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_view/renderer/renderer.rb:
17:in “render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1ib/abstract_controller/rendering.rb:
110:in ' _render_template'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/streaming
.rb:225:in " _render_template'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/abstract_controller/rendering.rb:
103:in "render_to_body'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/renderers
.rb:28:1in “render_to_body'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1ib/action_controller/metal/compatibi
lity.rb:50:in “render_to_body'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/abstract_controller/rendering.rb:
88:in “render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/rendering
.rb:16:1in "render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack—-3.2.8/1lib/action_controller/metal/instrumen
tation.rb:40:in "block (2 levels) in render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/core_ext/benchm
ark.rb:5:in “block in ms'

| /opt/rh/rubyl93/root/usr/share/ruby/benchmark.rb:295:in ‘realtime'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/core_ext/benchm
ark.rb:5:in "ms'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/instrumen
tation.rb:40:in "block in render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/instrumen
tation.rb:83:in “cleanup_view_runtime'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/railties/controll
er_runtime.rb:24:in “cleanup_view_runtime'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/instrumen
tation.rb:39:in "render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/implicit_
render.rb:10:1in “default_render'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/implicit
render.rb:5:1in “send_action'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/abstract_controller/base.rb:167:1
n ‘process_action'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/rendering
.rb:10:in “process_action'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/abstract_controller/callbacks.rb:
18:in "block in process_action'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:69
3:in "block (4 levels) in _run__ 3834324222800939617_ process_action_ 1167866121686859756__callback
sl

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:21
5:in “block in _conditional_callback_around_7884"

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:32
6:in “around'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:31
0:1in " _callback_around_3074"

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:21
4:in °_conditional_callback_around_7884"

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport—-3.2.8/1lib/active_support/callbacks.rb:62
6:in "block (3 levels) in _run__ 3834324222800939617__process_action__1167866121686859756__callback
S'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:21
5:1in "block in _conditional_callback_around_7883"'

| /usr/share/foreman/app/controllers/concerns/application_shared.rb:13:in "set_timezone'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:21
4:in °_conditional_callback_around_7883"

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport—-3.2.8/1lib/active_support/callbacks.rb:62
5:in "block (2 levels) in _run__3834324222800939617__ process_action__1167866121686859756__callback
S'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:21
5:1in "block in _conditional_callback_around_7882"'

| /usr/share/foreman/app/models/concerns/foreman/thread_session.rb:32:in ‘clear_thread’

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:21
4:in °_conditional_callback_around_7882"

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport—-3.2.8/1lib/active_support/callbacks.rb:44
8:in "block in _run_ 3834324222800939617__process_action__1167866121686859756__callbacks'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:21
5:1in "block in _conditional_callback_around_7881"'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:32
6:in “around'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:31
0:in " _callback_around_13"

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport—-3.2.8/1lib/active_support/callbacks.rb:21
4:in *_conditional_callback_around_7881"

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:41
4:in " _run__ 3834324222800939617__process_action_ 1167866121686859756__callbacks'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:40
5:1in "__run_callback'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:38
5:in ' _run_process_action_callbacks'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:81
:in “run_callbacks'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/abstract_controller/callbacks.rb:
17:in “process_action'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/rescue.rb
:29:in “process_action'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/instrumen
tation.rb:30:in "block in process_action'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r
b:123:in “block in instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport—-3.2.8/1lib/active_support/notifications/i
nstrumenter.rb:20:in " instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications.r
b:123:in "instrument'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/instrumen
tation.rb:29:in "process_action’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/params_wr
apper.rb:207:1in “process_action'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/railties/controll
er_runtime.rb:18:in “process_action'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1ib/abstract_controller/base.rb:121:1
n ‘process'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/abstract_controller/rendering.rb:
45:in “process'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal.rb:203:1in
“dispatch'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal/rack_dele
gation.rb:14:in “dispatch’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_controller/metal.rb:246:1in
"block in action’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/routing/route_set
.rb:73:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/routing/route_set
.rb:73:1in “dispatch’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/routing/route_set
.rb:36:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/journey-1.0.4/1ib/journey/router.rb:68:in ‘block in ca
11"

| /opt/rh/rubyl93/root/usr/share/gems/gems/journey-1.0.4/1ib/journey/router.rb:56:in “each'

| /opt/rh/rubyl93/root/usr/share/gems/gems/journey-1.0.4/1ib/journey/router.rb:56:in "call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/routing/route_set
.rb:600:in “call'

| /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.2.6/1lib/apipie/static_dispatcher.rb
:65:in “call'

| /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.2.6/1lib/apipie/extractor/recorder.r
b:97:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/static
.rb:62:in “call'

| /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.2.6/1lib/apipie/middleware/checksum_
in_headers.rb:27:in ‘call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/best_s
tandards_support.rb:17:in “call’

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack-1.4.1/1ib/rack/etag.rb:23:in “call’

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack-1.4.1/1ib/rack/conditionalget.rb:25:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/head.r
b:l4:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/params
_parser.rb:21:in “call'

| /usr/share/foreman/lib/middleware/catch_json_parse_errors.rb:9:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1ib/action_dispatch/middleware/flash.
rb:242:in “call’

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack-1.4.1/1ib/rack/session/abstract/id.rb:205:in "con
text'

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack-1.4.1/1lib/rack/session/abstract/id.rb:200:in “cal
l'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/cookie
s.rb:339:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/query_cache.rb:64
:in “call!

| /opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapte
rs/abstract/connection_pool.rb:473:in “call’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/callba
cks.rb:28:in "block in call’

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:40
5:in "_run__3410222765920685211__call_ 1581136245691807574__callbacks'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:40
5:in '__run_callback'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport—-3.2.8/1lib/active_support/callbacks.rb:38
5:in "_run_call_callbacks'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:81
:in “run_callbacks'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/callba
cks.rb:27:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/remote
_ip.rb:31:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/debug_
exceptions.rb:16:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/show_e
xceptions.rb:56:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/railties-3.2.8/1lib/rails/rack/logger.rb:26:in “call_ap
p'

| /opt/rh/rubyl93/root/usr/share/gems/gems/railties-3.2.8/1lib/rails/rack/logger.rb:16:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/reques
t_id.rb:22:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack—-1.4.1/1ib/rack/methodoverride.rb:21:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack-1.4.1/1ib/rack/runtime.rb:17:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/cache/strategy/
local _cache.rb:72:1in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack-1.4.1/1lib/rack/lock.rb:15:in “call’

| /opt/rh/rubyl93/root/usr/share/gems/gems/actionpack-3.2.8/1lib/action_dispatch/middleware/static
.rb:62:1in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack—cache-1.2/1lib/rack/cache/context.rb:136:in " forwa
rd'

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack—-cache-1.2/1lib/rack/cache/context.rb:245:in " fetch

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack-cache-1.2/1lib/rack/cache/context.rb:185:in "~ looku

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack—-cache-1.2/1lib/rack/cache/context.rb:66:in ‘call!’
| /opt/rh/rubyl93/root/usr/share/gems/gems/rack—cache-1.2/1lib/rack/cache/context.rb:51:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/railties-3.2.8/1lib/rails/engine.rb:479:in "call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/railties-3.2.8/1lib/rails/application.rb:223:in “call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/railties-3.2.8/1lib/rails/railtie/configurable.rb:30:1in
"method_missing'

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack-1.4.1/1ib/rack/builder.rb:134:in “call’

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack-1.4.1/1lib/rack/urlmap.rb:64:in “block in call'

| /opt/rh/rubyl93/root/usr/share/gems/gems/rack-1.4.1/1lib/rack/urlmap.rb:49:in "each'
I
|

[T

/opt/rh/rubyl93/root/usr/share/gems/gems/rack-1.4.1/1ib/rack/urlmap.rb:49:in “call'
/usr/share/gems/gems/passenger—-4.0.18/1lib/phusion_passenger/rack/thread_handler_extension.rb:77
:in “process_request'
| /usr/share/gems/gems/passenger—-4.0.18/1ib/phusion_passenger/request_handler/thread_handler.rb:1
40:in "accept_and_process_next_request'
| /usr/share/gems/gems/passenger—-4.0.18/1ib/phusion_passenger/request_handler/thread_handler.rb:1
08:in "main_loop'
| /usr/share/gems/gems/passenger—-4.0.18/1ib/phusion_passenger/request_handler.rb:441:in “block (3
levels) in start_threads'
| /opt/theforeman/tfm/root/usr/share/gems/gems/logging-1.8.2/1ib/logging/diagnostic_context.rb:32
3:in “call’
| /opt/theforeman/tfm/root/usr/share/gems/gems/logging-1.8.2/1ib/logging/diagnostic_context.rb:32
3:in "block in create_with_logging_context'
2016-02-03 10:32:00 [app] [I] Rendered common/500.html.erb (4.0ms)
2016-02-03 10:32:00 [app] [I] Completed 500 Internal Server Error in 68ms (Views: 5.1lms | ActiveRe
cord: 3.2ms)

Related issues:
Has duplicate Foreman - Bug #13920: Unable to view config reports in forman 1... Closed 02/26/2016

Associated revisions

Revision 640d7ee7 - 03/09/2016 01:14 PM - Justin Sherrill
Fixes #13545 - STI permission checking always using base class

This fixes permission checks on STl objects. Due to these methods existing
in Procs and being included in the base class at run time resource_class was
returning the base class. | can only presume this is related to a ruby or rails 4
upgrade

Revision 90d1f4bf - 03/10/2016 10:49 AM - Justin Sherrill

Fixes #13545 - STI permission checking always using base class

This fixes permission checks on STI objects. Due to these methods existing
in Procs and being included in the base class at run time resource_class was
returning the base class. | can only presume this is related to a ruby or rails 4
upgrade

(cherry picked from commit 640d7ee703ae347ee9dd5c21e341cb4d6a9874ec)
Revision 02823256 - 03/29/2016 02:55 PM - Justin Sherrill

Fixes #13545 - STI permission checking always using base class

This fixes permission checks on STl objects. Due to these methods existing
in Procs and being included in the base class at run time resource_class was
returning the base class. | can only presume this is related to a ruby or rails 4

upgrade

(cherry picked from commit 640d7ee703ae347ee9dd5c21e341cb4d6a9874ec)

History

#1 - 02/03/2016 10:35 AM - Dominic Cleal
- Subject changed from Error with templates-permissions to Editing template throws "undefined method “profile=' for nil:NilClass" error

- Description updated

#2 - 02/04/2016 09:08 AM - Tom Caspy

this is bizarre, looks like Host.authorized is getting to Host::Base.authorized (in which case, there is no scoped_search_definition on that class)
instead of Host::Managed.authorized
but | can't seem to be able to reproduce this...

Dima - can you put this in host.rb:14
Rails.logger.error "type is set to #{type}, args are #{args.inspect}"

and let us know what the output to the logger is?

#3 - 02/12/2016 04:29 AM - Otavio Piske

It seems that | have the same error. For me this problem occurs when | a user from a (slightly more privileged*) group tries to access the templates.
My reproducer steps are roughly like this:

1. Clone Edit Hosts, Site Manager, View Hosts and Viewer roles to create restricted versions of those (in my case, | want the users of this group to
access only the resources in the puppet environment 'ci').

1.1 Optionally create a template manager group, with full access to the templates (this does not seem to have any impact on the result)

2. Create a more privileged group (ie.: ci-admins) add the roles above to it.

Then, either:
1. Try to access the templates from the host page (after it has been built) or
2. Try to access the provisioning templates page.

Either way it causes the error above.
#4 - 02/27/2016 10:41 AM - The Foreman Bot
- Status changed from New to Ready For Testing

- Assignee set to Justin Sherrill

- Pull request https://github.com/theforeman/foreman/pull/3244 added

#5 - 02/27/2016 10:51 AM - Justin Sherrill

| was able to reproduce this with hosts pretty easily:

1. Create a role with a two filters ~ * unlimited 'view_hosts'  * 'view_statistics' under '(Miscellaneous)'
2. Create a user with that role
3. As that user try to fetch: /api/v2/statistics

#6 - 02/29/2016 09:13 AM - Justin Sherrill
- Bugzilla link set to 1312916

#7 - 03/01/2016 07:07 AM - Dominic Cleal

- Has duplicate Bug #13920: Unable to view config reports in forman 1.11 rc1 as non admin user added

#8 - 03/01/2016 07:09 AM - Dominic Cleal

- translation missing: en.field_release set to 145

Appears likely to affect templates from #7096 in 1.9, but also affects reports in 1.11 (from #4151) and hosts.

#9 - 03/09/2016 02:02 PM - Justin Sherrill
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 640d7ee703ae347ee9dd5c21e341cb4d6a9874ec.
